<?php
defined('_JEXEC') or die;


class ModCurrencyRatesProHelper
{

	private static $_instance = null;

	private $cbr = null;
	private $nbu = null;
	private $kbk = null;
	private $pbn = null;
	private $pbb = null;

	private function __construct()
	{
	}

	public static function getInstance()
	{
		if (!isset(self::$_instance))
		{
			self::$_instance = new self();
		}

		return self::$_instance;
	}

	public function getData($bank = 'nbu')
	{
		if (!isset($this->$bank))
		{
			$this->$bank = $this->$bank();
		}

		return $this->$bank;
	}

	protected function __clone()
	{
	}

	private function cbr()
	{
		$cbr = array();
		$xml = simplexml_load_file('http://www.cbr.ru/scripts/XML_daily.asp');
		if ($xml)
		{
			foreach ($xml as $val)
			{
				$CharCode       = (string) $val->CharCode;
				$cbr[$CharCode] = array(
					'unit' => (string) $val->Nominal,
					'sale' => str_replace(',', '.', (string) $val->Value)
				);
			}
		}

		return $cbr;
	}

	private function nbu()
	{
		$new_nbu  = array();
		$contents = file_get_contents('http://bank.gov.ua/NBUStatService/v1/statdirectory/exchange?json');
		$data     = json_decode($contents);
		if ($data)
		{
			foreach ($data as $curr)
			{

				$id = trim($curr->cc);

				if (empty($id))
					$id = (string) $curr->r030;

				if (!empty($id) && !empty($curr->txt) && !empty($curr->rate))
				{
					$new_nbu[$id] = array(
						'unit' => 1,
						'sale' => $curr->rate
					);
				}
			}
		}

		return $new_nbu;
	}

	private function kbk()
	{
		$kbk = array();
		$xml = simplexml_load_file('http://www.kredobank.com.ua/xml/exchange_rates_commercial.xml');
		if ($xml)
		{
			$currcodes = array('826' => 'GBP', '840' => 'USD', '124' => 'CAD', '985' => 'PLZ', '643' => 'RUR', '978' => 'EUR');
			foreach ($xml as $val)
			{
				$charcode       = $currcodes[(string) $val->Code];
				$kbk[$charcode] = array(
					'unit' => (string) ((string) $val->Buy['nominal'] == (string) $val->Sale['nominal'] ? $val->Sale['nominal'] : $val->Buy['nominal'] . '/' . $val->Sale['nominal']),
					'buy'  => (string) $val->Buy,
					'sale' => (string) $val->Sale
				);
			}
		}

		return $kbk;
	}

	private function pbn()
	{
		$pbn = array();
		$xml = simplexml_load_file('https://api.privatbank.ua/p24api/pubinfo?exchange&coursid=5');
		if ($xml)
		{
			foreach ($xml as $row)
			{
				foreach ($row as $val)
				{
					$pbn[(string) $val['ccy']] = array(
						'unit' => '1',
						'buy'  => (string) $val['buy'],
						'sale' => (string) $val['sale']
					);
				}
			}
		}

		return $pbn;
	}

	private function pbb()
	{
		$pbb = array();
		$xml = simplexml_load_file('https://api.privatbank.ua/p24api/pubinfo?exchange&coursid=11');
		if ($xml)
		{
			foreach ($xml as $row)
			{
				foreach ($row as $val)
				{
					$pbb[(string) $val['ccy']] = array(
						'unit' => '1',
						'buy'  => (string) $val['buy'],
						'sale' => (string) $val['sale']
					);
				}
			}
		}

		return $pbb;
	}


}
